package com.pcitc.si.gateway.security;

import cn.hutool.core.convert.Convert;
import cn.hutool.core.util.StrUtil;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Map;
import java.util.function.Function;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.http.HttpMethod;
import org.springframework.http.server.reactive.ServerHttpRequest;
import org.springframework.security.authorization.AuthorizationDecision;
import org.springframework.security.authorization.ReactiveAuthorizationManager;
import org.springframework.security.web.server.authorization.AuthorizationContext;
import org.springframework.stereotype.Component;
import org.springframework.util.AntPathMatcher;
import org.springframework.web.server.WebSession;
import reactor.core.publisher.Mono;

@Component
public class AuthorizationManager implements ReactiveAuthorizationManager {

   private static final Logger log = LoggerFactory.getLogger(AuthorizationManager.class);
   private final RedisTemplate redisTemplate;


   public static void main(String[] args) {
      AntPathMatcher pathMatcher = new AntPathMatcher();
      boolean b = pathMatcher.matchStart("/00101????/**", "/001010001/admin");
      System.out.println(b);
   }

   public Mono check(Mono mono, AuthorizationContext authorizationContext) {
      final ServerHttpRequest request = authorizationContext.getExchange().getRequest();
      String path = request.getURI().getPath();
      AntPathMatcher pathMatcher = new AntPathMatcher();
      if(request.getMethod() == HttpMethod.OPTIONS) {
         return Mono.just(new AuthorizationDecision(true));
      } else if(!pathMatcher.match("/*.png", path) && !pathMatcher.match("/*.svg", path)) {
         String token = request.getHeaders().getFirst("Authorization");
         if(StrUtil.isBlank(token)) {
            if(request.getMethod() == HttpMethod.GET) {
               Mono resourceRolesMap1 = authorizationContext.getExchange().getSession();
               return resourceRolesMap1.flatMap(new Function() {
                  public Mono apply(WebSession session) {
                     String redirect = (String)request.getQueryParams().getFirst("redirect");
                     if(redirect != null && !redirect.isEmpty()) {
                        session.getAttributes().put("redirect", redirect);
                     }

                     return Mono.just(new AuthorizationDecision(false));
                  }
               });
            } else {
               return Mono.just(new AuthorizationDecision(false));
            }
         } else {
            Map resourceRolesMap = this.redisTemplate.opsForHash().entries("auth:resourceRoles");
            Iterator iterator = resourceRolesMap.keySet().iterator();
            HashSet authorities = new HashSet();

            while(iterator.hasNext()) {
               String authorizationDecisionMono = (String)iterator.next();
               if(pathMatcher.match(authorizationDecisionMono, path)) {
                  authorities.addAll(Convert.toList(String.class, resourceRolesMap.get(authorizationDecisionMono)));
               }
            }

            Mono authorizationDecisionMono1 = mono.filter(test<invokedynamic>()).flatMapIterable(apply<invokedynamic>()).map(apply<invokedynamic>()).any(test<invokedynamic>(path)).map(apply<invokedynamic>()).defaultIfEmpty(new AuthorizationDecision(false));
            return authorizationDecisionMono1;
         }
      } else {
         return Mono.just(new AuthorizationDecision(true));
      }
   }

   public AuthorizationManager(RedisTemplate redisTemplate) {
      this.redisTemplate = redisTemplate;
   }

   // $FF: synthetic method
   private static boolean lambda$check$0(String path, String roleId) {
      log.info("访问路径：{}", path);
      return true;
   }

}
